/* Cut and Paste from
	http://lists.soekris.com/pipermail/soekris-tech/2003-February/001959.html
*/

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/watchdog.h>

int
main(int argc, char **argv)
{
        int fd;
        int i, j;
        unsigned u;

        fd = open("/dev/elan-mmcr", O_RDWR);
        if (fd < 0)
                err(1, "/dev/elan-mmcr");

        /*
         * Set a two second timeout, but reset it after one second.
	 * Do this five times to see that it works as advertised.
         */
        for (j = 0; j < 5; j++) {
                u = WD_ACTIVE | WD_TO_2SEC;
                i = ioctl(fd, WDIOCPATPAT, &u);
                printf("2SEC %d %d\n", i, errno);
                sleep (1);
        }
        /*
         * Turn the watchdog off.
	 * Wait twice the previous timeout, we should survive.
         */
        u = 0;
        i = ioctl(fd, WDIOCPATPAT, &u);
        printf("OFF %d %d\n", i, errno);
        sleep (5);
        /*
         * Set a two second timeout, and let it, and us, expire.
         */
        u = WD_ACTIVE | WD_TO_2SEC;
        i = ioctl(fd, WDIOCPATPAT, &u);
        printf("2SEC %d %d\n", i, errno);
        sleep (5);

        /*
         * We shouldn't get here alive.
         */
        printf("Where's the kaboom ?\n");
        exit (0);
}
